{$H+,StdCall+}
Unit cRegExp;
interface
Uses Windows;

const
 MatchesNum            = $10;
 rSharedKey   : String = 'Software\Far\Plugins\Shared';
 rRegExp      : String = 'RegExp';
 rColoring    : String = 'Coloring';
 rColorBaseHrc: String = 'ColorBaseHrc';

type
 pRegExp = Pointer;

 pMatches = ^tMatches;
 tMatches = packed record
  s: packed array[0..MatchesNum-1] of System.Integer;
  e: packed array[0..MatchesNum-1] of System.Integer;
  curMatch: System.Integer;
 end;

 tColorerCreate        = function: pRegExp;
 tColorerCreateCompile = function(RegExp: pChar): pRegExp;
 tColorerDestroy       = function(re: pRegExp): Boolean;
 tColorerSetNoMoves    = function(re: pRegExp; Moves: Boolean): Boolean;
 tColorerSetBkTrace    = function(re: pRegExp; st: pChar; Trace: pMatches): Boolean;
 tColorerSetExpr       = function(re: pRegExp; expr: pChar): Boolean;
 tColorerParse         = function(re: pRegExp; st: pChar; Matches: pMatches): Boolean;
 tColorerParseParam    = function(re: pRegExp; st,s,e: pChar; Matches: pMatches; Moves: Boolean): Boolean;

 pColorerRegExpClass = ^tColorerRegExpClass;
 tColorerRegExpClass = packed record
  size: Integer;
  reCreate       : tColorerCreate;
  reCreateCompile: tColorerCreateCompile;
  reDestroy      : tColorerDestroy;
  reSetNoMoves   : tColorerSetNoMoves;
  reSetBkTrace   : tColorerSetBkTrace;
  reSetExpr      : tColorerSetExpr;
  reParse        : tColorerParse;
  reParseParam   : tColorerParseParam;
 end;

 tColorerRegExpProc    = function(RegExpClass: pColorerRegExpClass): Boolean;

 function GetLibraryPath(var Path: String; RegName: String): Boolean;

implementation
Uses Strings,Plugin;

function GetLibraryPath(var Path: String; RegName: String): Boolean;
 begin
  result:=GetStringRegKey(rSharedKey,RegName,Path);
 end;

end.
